#!/bin/csh -f

#
# Default/setup variables (generated by Install)
#
__default-setup-var__



#
# Sanity check, make sure script and executable are same version
#
set runMajorVer="`/bin/cat $RAYZROOT/.VERSION`"
if ( $majorVer != $runMajorVer ) then
	echo "Sorry, you are trying to run Rayz $runMajorVer with a"
	echo "script ($0) created to run Rayz $majorVer."
	exit 1
endif


#
# Make sure we can run on this system
#
set osType=`/bin/uname -s | /bin/sed 's/64$//'`
set osVer=`/bin/uname -r`

if ( ($osType != "IRIX" && $osType != "Linux") || \
	 ($osType == "IRIX" && $osVer !~ 6.[2345]) ) then
	echo "Rayz $majorVer doesn't run on $osType $osVer."
	echo "It only runs on IRIX 6.X and Linux."
	exit 1
endif


#
# Which directory to use for temp stuff
#
if ( ! $?RAYZ_TMPDIR ) then
	if ( $?TMPDIR ) then
		setenv RAYZ_TMPDIR  $TMPDIR
	else
		if ( $?TEMP ) then
			setenv RAYZ_TMPDIR  $TEMP
		else
			setenv RAYZ_TMPDIR  $default_tmpdir
		endif
	endif
endif


#
# Which html browser to use for help
#
if ( ! $?RAYZ_HELP_BROWSER )  setenv RAYZ_HELP_BROWSER  $default_help_browser


#
# Other variables added by user (generated by Install)
#
__user-added-vars__


#
# Actually run the program
#
$RAYZROOT/bin/rayz --tag $$ $argv
set exitStatus=$status


#
# Cleanup after ourselves
#
set dir=$RAYZ_TMPDIR/Rayz.$$

if ( -e $dir ) then
	#
	# kill off dead files
	#
	foreach file ( `/usr/bin/find $dir -name \*.pids -print` )
		foreach pid ( `/usr/bin/cat $file` )
			(/bin/kill -9 $pid >& /dev/null)
		end
	end

	/bin/rm -rf $dir
endif

exit $exitStatus


