/*
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
// Produced by:
//  Silicon Grail Corporation
//  736 N. Seward
//  Hollywood, CA
//  USA 90038
//  323-871-9100
//
// NAME:    Cube
//
// COMMENTS: return the input cubed
//
*/

#include <stdio.h>
#include <math.h>
#include <CPI.h>

const char CubeHelp[] =
	"cube( x ) : Returns the cube of x";

/////////////////////////////////////////
// Init is called when the expression is created

static CPI_Bool
CubeInit( void )
{
	return CPI_TRUE;
}


/////////////////////////////////////////
// Shutdown is called when the expression is shut down

static CPI_Bool
CubeShutdown( void )
{
	return CPI_TRUE;
}


//////////////////////////////////////////
// This is called when the expression is actually executed
// You can assume that numArgs is within the bounds specified
// in the exinfo structure, but other validation of input
// is up to the programmer.

CPI_Bool
CubeApply( const CPI_Float32		 args[],
		   CPI_Uint32		 		 numArgs,
		   CPI_Float32   			*result )

{
	CPI_Bool	retval	= CPI_TRUE;
	
	*result = args[0] * args[0] * args[0];

	return retval;
}


/////////////////////////////////////
// This structure defines the image op (IM) that you
// make. It is required if you are creating your own IM

static RPI_ExpressionInfo exinfo = 
{
	{
		"cube",				// command name
		"",			        // not used
		"Joe Programmer",	// author
		"0.1",				// version
		NULL, NULL
	},
	CubeInit,				// init expression
	CubeShutdown,			// shutdown
	CubeApply,				// apply,
	CubeHelp,            	// help string
	1,						// min number of arguments
	1						// max number of arguments
};


////////////////////////////////////
// register the expression
// This routine and the next are required, and they should
// be declared as shown, in order to work in both NT and
// linux/IRIX

CPIDSOEXPORT CPI_Bool
rpiPluginInit( void )
{
	CPI_Bool retval = CPI_TRUE;

	retval =  cpiRegisterExpression( &exinfo );

	return retval;	
}


//////////////////////////////////////////////
// unregister node and image op

CPIDSOEXPORT void
upiPluginCleanup( void )
{
	cpiUnregisterExpression( "cube" );
}
