/*
//
// NAME:		Com.h
//
// COMMENTS:
//		 Header file for the Com format file reader
*/


#include <CPI.h>

/* define header for this format */

typedef struct {
	CPI_Uint32	magic;
	CPI_Uint32	xsize;
	CPI_Uint32	ysize;
	CPI_Uint8	spare[116];		/* for future expansion */
} ComHeader;

typedef struct _imageState
{
	CPI_DeviceHandle	myDevice;
	ComHeader			myHeader;
} imageState;

#define MAGICNUM	42
#define HEADERSIZE	sizeof( ComHeader )

/* declare function signatures as required in API */

static CPI_Bool		ComInit( CPI_Bool initforread );
static CPI_Bool		ComShutDown( void );
static CPI_PrivateData ComOpenForRead( const CPI_Metadata    meta,
									   CPI_Metadata          imageinfo );
static CPI_Bool 		ComReadImage( CPI_PrivateData handle, CPI_Image *image );
static CPI_PrivateData	ComOpenForWrite( const CPI_Metadata	meta,
										 CPI_Metadata		imageinfo );
static CPI_Bool		ComWriteImage( CPI_PrivateData	 handle,
								   CPI_Image		*image );
static CPI_Bool		ComCloseImage( CPI_PrivateData	 handle );

/* specific to the format */

static void		SwapComHeader( ComHeader *header);

static CPI_Bool		PackCom8( CPI_Uint8		*packed,
							  CPI_Uint8		*unpacked,
							  CPI_Uint64	 pixels,
							  CPI_Int32		 channels );

static CPI_Bool		PackCom16( CPI_Uint8	*packed,
							   CPI_Uint16	*unpacked,
							   CPI_Uint64	 pixels,
							   CPI_Int32	 channels );

static CPI_Bool		PackComF( CPI_Uint8		*packed,
							  CPI_Float32	*unpacked,
							  CPI_Uint64	 pixels,
							  CPI_Int32		 channels );

static CPI_Bool		UnPackCom( CPI_Uint8	*packed,
							   CPI_Uint8	*unpacked,
							   CPI_Uint64	 pixels );

