/*
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
// Produced by:
//  Silicon Grail Corporation
//  736 N. Seward
//  Hollywood, CA
//  USA 90038
//  323-871-9100
*/


#ifndef _CPI_CurveID_h_
#define _CPI_CurveID_h_

#include <CPI/CPI_Types.h>


#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************
 ** Curve ID list utility functions
 **
 ** A Curve ID is a generic string descriptor for a curve.
 ** It is intended to be generated by an openForImport call for use in places
 ** like the Curve Browser info panel, where you can select how to import
 ** curves into Rayz.
 **
 *****************************************************************************/


CPIDSOIMPORT CPI_CurveIDList cpiCreateCurveIDList( void );
CPIDSOIMPORT void			 cpiDeleteCurveIDList( CPI_CurveIDList idlist );

CPIDSOIMPORT CPI_Uint32		 cpiGetCurveIDListSize( CPI_CurveIDList idlist );

CPIDSOIMPORT void			 cpiAddCurveIDToList( CPI_CurveIDList	 idlist,
												  const char		*curveid );
CPIDSOIMPORT const char		*cpiGetCurveIDFromList( CPI_CurveIDList	 idlist,
													CPI_Uint32		 idx );


#ifdef __cplusplus
}
#endif

#endif /* _CPI_CurveID_h_ */
