/*
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
// Produced by:
//  Silicon Grail Corporation
//  736 Seward St
//  Hollywood, CA
//  USA 90038
//  323-871-9100
*/

#ifndef _CPI_Device_h_
#define _CPI_Device_h_

#include <CPI/CPI_Base.h>

#ifdef __cplusplus
extern "C" {
#endif

CPIDSOIMPORT CPI_DeviceHandle	 cpiOpen( CPI_Metadata meta );
CPIDSOIMPORT CPI_Bool			 cpiIsOpen( CPI_DeviceHandle device );

CPIDSOIMPORT void				 cpiClose( CPI_DeviceHandle device );

CPIDSOIMPORT void				 cpiSync( CPI_DeviceHandle device );

CPIDSOIMPORT CPI_Uint64			 cpiSetPosition( CPI_DeviceHandle	 device,
												 CPI_Int64			 pos,
												 CPI_Uint8			 whence );
CPIDSOIMPORT CPI_Uint64			 cpiGetPosition( CPI_DeviceHandle	 device );
CPIDSOIMPORT CPI_Bool			 cpiFileLength( CPI_DeviceHandle	 device,
												CPI_Uint64			*length );

CPIDSOIMPORT CPI_Uint64			 cpiRead( CPI_DeviceHandle	 device,
										  char				*buffer,
										  CPI_Uint64		 count );
CPIDSOIMPORT CPI_Uint64			 cpiWrite( CPI_DeviceHandle	 device,
										   const char		*buffer,
										   CPI_Uint64		 count );
CPIDSOIMPORT CPI_Metadata		 cpiGetMetadataForOpen( const char	*fileid,
														const char	*filemgr,
														CPI_Float32	 time );
	
#ifdef __cplusplus
}
#endif

#endif /* _CPI_Device_h_ */

